# Session Token

The [session token](../../config/ruleset/session_token.json) consists of 9 main rules and serves as the successor to the [session_prefix](../../config/ruleset/session_prefix.json) rule, which includes a broader set of rules. The rules are as follows:

1. `version`: Shows the version of the HTTP Router it's running. During deployments this endpoint is used to ensure the deployed HTTP Router version is available.
2. `session_token_header_job_token`: Analyzes the `JOB-TOKEN` in the headers and checks if it matches the [defined pattern](https://gitlab.com/gitlab-org/cells/http-router/-/blob/7d0b5ed701323a3002d1b08695562d702f48c647/config/ruleset/session_token.json#L16) `^glcbt-(?<headers>[0-9A-Za-z_-]+)\\.(?<payload>[0-9A-Za-z_-]+)\\.(?<signature>[0-9A-Za-z_-]+)$`. If the pattern matches, the token is decoded using [Base64](https://developer.mozilla.org/en-US/docs/Glossary/Base64) decoding to extract its payload. The decoded payload is then validated to ensure all required information is present. If any required data is missing, the process moves to the next rule; otherwise, the token is classified using the `CELL_ID` in the Topology Service.
   The Topology Service then responds with the corresponding Cell domain to proxy the request.

   ![session token demo](../../imgs/session-token.png)

   [source](https://excalidraw.com/#json=EgCAqEUTF1lENfg8OAA9i,ssAq3l1zsl_poR9z34njRg)
3. `session_token_header_private_token_job_token`: Analyzes the `PRIVATE-TOKEN` in the headers and checks if it matches the [defined pattern](https://gitlab.com/gitlab-org/cells/http-router/-/blob/7d0b5ed701323a3002d1b08695562d702f48c647/config/ruleset/session_token.json#L41) `^glcbt-(?<headers>[0-9A-Za-z_-]+)\\.(?<payload>[0-9A-Za-z_-]+)\\.(?<signature>[0-9A-Za-z_-]+)$`. If the pattern matches, the token is decoded using [Base64](https://developer.mozilla.org/en-US/docs/Glossary/Base64) decoding to extract its payload. The decoded payload is then validated to ensure all required information is present. If any required data is missing, the process moves to the next rule; otherwise, the token is classified using the `CELL_ID` in the Topology Service.
   The Topology Service then responds with the corresponding Cell domain to proxy the request.
4. `session_token_query_string_job_token`: Analyzes the `job_token` in the query string and checks if it matches the [defined pattern](https://gitlab.com/gitlab-org/cells/http-router/-/blob/7d0b5ed701323a3002d1b08695562d702f48c647/config/ruleset/session_token.json#L66) `^glcbt-(?<headers>[0-9A-Za-z_-]+)\\.(?<payload>[0-9A-Za-z_-]+)\\.(?<signature>[0-9A-Za-z_-]+)$`. If the pattern matches, the token is decoded using [Base64](https://developer.mozilla.org/en-US/docs/Glossary/Base64) decoding to extract its payload. The decoded payload is then validated to ensure all required information is present. If any required data is missing, the process moves to the next rule; otherwise, the token is classified using the `CELL_ID` in the Topology Service.
   The Topology Service then responds with the corresponding Cell domain to proxy the request.
5. `session_token_header_runner_token`: Analyzes the `PRIVATE-TOKEN` in the headers and checks if it matches the [defined pattern](https://gitlab.com/gitlab-org/cells/http-router/-/blob/7d0b5ed701323a3002d1b08695562d702f48c647/config/ruleset/session_token.json#L66) `^(glrt-)?t\\d+_(?<payload>[0-9A-Za-z_-]{27,300})\\.(?<payload_length>[0-9a-z]{2})[0-9a-z]{7}$`. If the pattern matches, the token is decoded using [Base64](https://developer.mozilla.org/en-US/docs/Glossary/Base64) decoding to extract its payload. The decoded payload is then validated to ensure all required information is present. If any required data is missing, the process moves to the next rule; otherwise, the token is classified using the `CELL_ID` in the Topology Service.
   The Topology Service then responds with the corresponding Cell domain to proxy the request.
6. `session_token_header_authorization_pat`: Analyzes the `Authorization` in the headers and checks if it matches the [defined pattern](https://gitlab.com/gitlab-org/cells/http-router/-/blob/7d0b5ed701323a3002d1b08695562d702f48c647/config/ruleset/session_token.json#L92) `^Bearer (?<prefix_and_payload>[0-9A-Za-z_-]{27,320})\\.(?<payload_length>[0-9a-z]{2})[0-9a-z]{7}$`. If the pattern matches, the token is decoded using [Base64](https://developer.mozilla.org/en-US/docs/Glossary/Base64) decoding to extract its payload. The decoded payload is then validated to ensure all required information is present. If any required data is missing, the process moves to the next rule; otherwise, the token is classified using the `CELL_ID` in the Topology Service.
   The Topology Service then responds with the corresponding Cell domain to proxy the request.
7. `session_token_header_private_token_pat`: Analyzes the `PRIVATE-TOKEN` in the headers and checks if it matches the [defined pattern](https://gitlab.com/gitlab-org/cells/http-router/-/blob/7d0b5ed701323a3002d1b08695562d702f48c647/config/ruleset/session_token.json#L118) `^(?<prefix_and_payload>[0-9A-Za-z_-]{27,320})\\.(?<payload_length>[0-9a-z]{2})[0-9a-z]{7}$`. If the pattern matches, the token is decoded using [Base64](https://developer.mozilla.org/en-US/docs/Glossary/Base64) decoding to extract its payload. The decoded payload is then validated to ensure all required information is present. If any required data is missing, the process moves to the next rule; otherwise, the token is classified using the `CELL_ID` in the Topology Service.
   The Topology Service then responds with the corresponding Cell domain to proxy the request.
8. `session_token_query_string_pat`: Analyzes the `private_token` in the query string and checks if it matches the [defined pattern](https://gitlab.com/gitlab-org/cells/http-router/-/blob/7d0b5ed701323a3002d1b08695562d702f48c647/config/ruleset/session_token.json#L144) `^(?<prefix_and_payload>[0-9A-Za-z_-]{27,320})\\.(?<payload_length>[0-9a-z]{2})[0-9a-z]{7}$`. If the pattern matches, the token is decoded using [Base64](https://developer.mozilla.org/en-US/docs/Glossary/Base64) decoding to extract its payload. The decoded payload is then validated to ensure all required information is present. If any required data is missing, the process moves to the next rule; otherwise, the token is classified using the `CELL_ID` in the Topology Service.
   The Topology Service then responds with the corresponding Cell domain to proxy the request.
9. `session_prefix_gitlab_session`: Analyzes the `_gitlab_session` cookie and checks if it matches the [defined pattern](https://gitlab.com/gitlab-org/cells/http-router/-/blob/7d0b5ed701323a3002d1b08695562d702f48c647/config/ruleset/session_token.json#L170) `^(?<cell_name>cell-\\d+)-.*`, (example: `cell-3-ece7c168aa88`), classifies the value using Topology Service.
   The Topology Service then responds with the corresponding Cell domain to proxy the request.

   ![session prefix demo](../../imgs/session-prefix.png)

   [source](https://excalidraw.com/#json=z7-ihTQ69trj5vdpXZ-7V,k0NtksWZMRdaR-lHoH3JMQ)
10. `session_token_proxy`: The default route - if nothing matches, proxies to the Legacy Cell in passthrough mode.

   The [Force Login to a Specific Cell](session_prefix.md#force-login-to-a-specific-cell) is available.

***

The rules `session_token_header_job_token`, `session_token_header_private_token_job_token`, `session_token_query_string_job_token`, and `session_token_header_runner_token` handle CI requests, while `session_token_header_authorization_pat`, `session_token_header_private_token_pat`, `session_token_query_string_pat`, and `session_prefix_gitlab_session` manage API authentication. For more details on authentication methods, see the [REST API authentication](https://docs.gitlab.com/api/rest/authentication/) documentation.
